/*
 * @(#)InfoBrowser.java
 */

//package classes;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.net.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

/**
 * Wavelet Transformation Demo:
 * Browser for HTML-files
 * @author: Christoph Esser, eMail: esser@uni-mannheim.de
 *          Original version by Susanne Krabbe, University of Mannheim
 * @version: January 2001
 */

public class InfoBrowser extends JFrame {
	private JEditorPane jt;      //HTML-file display area
	private JButton close;       
	private URL url = null;
	

  /**
  	* Standard constructor (without HTML file display)
	*/
	public InfoBrowser() {
		super("Multiresolution Analysis Applet: Help");
		
		jt = new JEditorPane();
      jt.setEditable(false);
		//jt.setBackground(TransformDisplay.COL_BACK);
            
      JScrollPane scroller = new JScrollPane();
      Border b = BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(10, 10, 2, 10), BorderFactory.createEtchedBorder());
      scroller.setBorder(b);
      scroller.add(jt);
      JViewport vp = scroller.getViewport();
		  //vp.setBackground(TransformDisplay.COL_BACK);
      vp.add(jt);

      close = new JButton("Close window");
      close.addActionListener(new ActionListener(){
         public void actionPerformed(ActionEvent ae) {
             dispose();
         }
      });
		//Hyperlink action
      jt.addHyperlinkListener(new HyperlinkListener() {
			public void hyperlinkUpdate(final HyperlinkEvent e){
				if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
					setPage(e.getURL());
				
			}
		});
		
      JPanel closePan = new JPanel();
      closePan.setLayout(new FlowLayout(FlowLayout.RIGHT));
      closePan.add(close);
      closePan.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 5));
 
      Container c = getContentPane();
      c.add(scroller, BorderLayout.CENTER);
      c.add(closePan, BorderLayout.SOUTH);
            
      setBounds(30,30,600,600);
	}
	

  /**
	* Displays a given HTML-file
	* @param pageURL The HTML file name
	*/
	public void setPage(final URL pageURL) {
		//use EventDispatcher for page display
		SwingUtilities.invokeLater(new Runnable() {
			
			public void run() {
				try { 
					jt.setPage(pageURL); 
					//finally show the frame
					setVisible(true);
				}catch (IOException io){
					JOptionPane.showMessageDialog(null, "Invalid Url: "+pageURL, "Runtime Error", JOptionPane.ERROR_MESSAGE);
				}
			}
		});
	}

	
	/**
	* Displays a given HTML-file
	* @param path The path to the HTML file (without file name)
	* @param page The HTML file name
	*/
	public void setPage(URL path, String page) {
		//try to create a complete URL
		try { 
			URL pageURL = new URL(path, page);
			setPage(pageURL);
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Invalid Url: "+path.toString()+page, "Runtime Error", JOptionPane.ERROR_MESSAGE);
		}
	}

}  //end of class