package transformation;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

/**
*A <em>TransformationPanel</em> is a <code>JPanel</code>
*on which the multiresolution-animation is painted
*@version 26/05/2001
*@author Julia Schneider
*/
public abstract class AnalysePanel extends TransformationPanel{
		
	public abstract void transform( Graphics g, int i, int pos, 
		Color color );
	
	/**
	*this method prepares the actual transformation and
	*starts it the animation by starting the Timer-object timer
	*which now will fire ActionEvents every speed*milliseconds
	*causing the transformation to develop
	*@param g Graphics object of paintComponent(...)
	*@see actionPerformed(ActionEvent e)
	*/
	public void startTransformation( Graphics g){
				
		int start=0, end=0, pos=0;
		Color color = Color.black;
		
		if( filter.actualFilter().equals("approximation") ){
			start = 0;
			end = transformed[depth].getBorder();
			color = Grid.red;
			setBackground( backRed );
			g.setColor( Grid.red );
			g.setFont( new Font("Serif",Font.BOLD, 22) );
			g.drawString( "!!!Low Pass in Action!!!", width/2-115, 
				height-	Grid.getGap()-20 );
		}else if( filter.actualFilter().equals("detail")){
			start = transformed[depth].getBorder();
			end = 2 * transformed[depth].getBorder();
			color = Grid.green;
			setBackground( backGreen );
			g.setColor( Grid.green );
			g.setFont( new Font("Serif",Font.BOLD, 22) );
			g.drawString( "!!!High Pass in Action!!!", width/2-115, 
				height-	Grid.getGap()-20 );
			for( int i = 0; i < transformed[depth].getBorder();i++){
				transformed[depth].drawValue(g, i, Grid.red );
			}
		}

		for( int i = start; i < end; i++){
			if( filter.actualFilter().equals("approximation")){
			  pos = i;
			}else if( filter.actualFilter().equals("detail")){
				pos = i - transformed[depth].getBorder();
			}
		
		//starting the animation	
		transform( g, i, pos, color );
		}
	}//end of startTransformation
	
	/**
	*draws an animated Grid
	*/
	public void drawAnimGrid( Graphics g ){			
		//System.out.println("animateGrid");
		timer.stop();
		for( int i = 0; i < gridCheckTime.length; i++){
			if( gridCheckTime[i] ){
				animGrid[i].drawAnimatedGrid(g, transformed[i].origin(),
					(i+1)*signal.getGap()+(i+1)*10);
					if( animGrid[i].finished() ){
						//System.out.println("animGrid"+i+"finished");
						animateGrid = false;
						gridCheckTime[i] = false;
						if( i < gridCheckTime.length-1 ){
							gridCheckTime[i+1] = true;
						}
						//System.out.println( "counter = " + counter );
						//System.out.println( "gridCheckTime" + i +
						//	" " + gridCheckTime[i] );
						depth++;
						startTransform = true;
						timer.restart();
					}
			}
		}
	}//end of drawAnimGrid()
	
}//end of class
	
	
	