package transformation;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class AnimatedGrid implements ActionListener{
	private Grid grid;
	private JPanel panel;
	private Timer t;
	private Point p1;
	private boolean firstTime, finished;
	private int yEnd, counter;
	
	public AnimatedGrid( Grid g, JPanel p ){
		grid = g;
		panel = p;
		t = new Timer(1, this);
		firstTime = true;
	}
	
	public void drawAnimatedGrid( Graphics g, int yEnd  ){
		drawAnimatedGrid( g, grid.origin(), yEnd );
	}
	
	public void drawAnimatedGrid( Graphics g, Point p1, int yEnd){
		if( firstTime ){
			//System.out.println("firstTime AnimatedGrid");
			this.p1 = p1;
			this.yEnd = yEnd;
			firstTime = false;
			t.start();
		}
		
		int y =(int) (p1.getY()- counter * 0.75*Grid.getGap() );
	
		grid.drawGrid(g, (int) p1.getX(), y, Color.white);
		
		for( int i = 0; i < grid.getLength(); i++ ){
				grid.drawValue(g, i);
		}
	}

	public void reset(){
		firstTime = true;
		finished = false;
		counter = 0;
	}
	
	public boolean finished(){
		return finished;
	}
		
	public boolean isRunning(){
		return t.isRunning();
	}
	
	public void stopTimer(){
		t.stop();
	}
	
	public void restartTimer(){
		t.restart();
	}
	
	public void actionPerformed( ActionEvent e ){
		if( p1.getY()-(counter+0.25)*0.75*Grid.getGap()  > yEnd ){
			//System.out.println("counter "+counter);
			counter++; 
			panel.repaint();
		}else{
			//System.out.println( "AnimatedGrid finished" );
			finished = true;
			t.stop();	
			panel.repaint();
		}
	}

}
		