package transformation;

public abstract class Filter extends Grid{
	private int depth; //depth of transformation
	private double[] approximation, detail,
		synthesis1, synthesis2;
	private String actualFilter;
		
	public void fold( Grid source, Grid[] destination ){
		fold( source, destination[0] );


		/*System.out.println("transformed[0]");
		for ( int j = 0; j < destination[0].getLength(); j++ ){
				System.out.print(""+destination[0].get(j)+"\t" );
			}
		System.out.println("\n");*/
			
		
		for( int i = 1; i < destination.length; i++){
			destination[i].setValues( destination[i-1].getValues() );
			fold( destination[i-1], destination[i] );
			
			/*System.out.println("transformed["+i+"]");
			for ( int j = 0; j < destination[i].getLength(); j++ ){
				System.out.print(""+destination[i].get(j)+"\t" );
			}
			System.out.println("\n");*/
		}
		source.roundValues();
		for( int i = 0; i < destination.length; i++){
			destination[i].roundValues();
		}

	}
	
	public void fold( Grid source, Grid destination ){
		int pos=0;
		double dummy=0;
	  		
		for( int i = 0; 
				i < (int) (source.getLength()/Math.pow(2, depth)); i+=2){
			for( int j = 0; j < approximation.length; j++){
				dummy += source.get((i+j)% source.getLength())*approximation[j];
				
			}
			destination.set( pos, dummy);
			dummy = 0;
			pos++;
		}
		
		for( int i = 0; 
			i < (int) (source.getLength()/Math.pow(2, depth)); i+=2 ){
			for( int j = 0; j < detail.length; j++){
				dummy += source.get((i+j)%source.getLength())*detail[j];
			}
			destination.set( pos, dummy);
			dummy = 0;
			pos++;
		}
		
		depth++;
		destination.setBorder((int) (source.getLength()/Math.pow(2, depth)));
	}	
	
	
	public int length(){
		return approximation.length;
	}
	
	public void setApproximation( double[] d ){
		approximation = d;
	}
	
	public double[] getApproximation(){
		actualFilter = "approximation"; 
		return approximation;
	}

	public void setDetail( double[]  d){
		detail = d;
	}
	
	public double[] getDetail(){
		actualFilter = "detail";
		return detail;	
	}

	
	public void setSynthesis1( double[]  d){
		synthesis1 = d;
	}
	
	public double[] getSynthesis1(){
		actualFilter = "synthesis1";
		return synthesis1;
	}
	
	public void setSynthesis2( double[]  d){
		synthesis2 = d;
	}
	
	public double[] getSynthesis2(){
		actualFilter = "synthesis2";
		return synthesis2;
	}
	
	public String actualFilter(){
		return actualFilter;
	}
	
	
}