package transformation;
import java.awt.*;


/**
*A <em>SynthesisPanel</em> is a <code>TransformationPanel</code>
*on which the multiresolution-synthesis-animation is painted
*@version 26/05/2001
*@author Julia Schneider
*/
public abstract class SynthesisPanel extends TransformationPanel{

			
	/**
	* this method implements the actual synthesis-animation
	*@param g Graphics Object for painting
	*@param i position where the filter is to be painted
	*@param color background color of the filter
	*/
	public abstract void transform( Graphics g, int i,Color color );

	/**
	*this method prepares the animation of the
	*synthesis 
	*@param g Graphics object of paintComponent(...)
	*/
	public void startTransformation( Graphics g){
				
		Color color = Color.black;
		g.setFont( new Font("Serif",Font.BOLD, 22) );
		
		if( filter.actualFilter().equals("synthesis1") ){
			color = Grid.red;
			setBackground( backRed );
			g.setColor( Grid.red );
			g.drawString( "!!!1.Synthesis Filter in Action!!!", width/2-115, 
			height-	Grid.getGap()-20 );
		}else if( filter.actualFilter().equals("synthesis2")){
			color = Grid.green;
			setBackground( backGreen );
			g.setColor( Grid.green );
			g.drawString( "!!!2.Synthesis Filter in Action!!!", width/2-115, 
				height-	Grid.getGap()-20 );
		
		
		}//end of if (filter.actualfilter.equals(...)

		/*
		for ( int i = 0; i < 16/Math.pow(2, 3-depth); i++ ){
			transform( g, i,  color );
		}*/
			
	}//end of startTransformation()
	
	
	/**
	*draws an animated Grid
	*/
	public void drawAnimGrid( Graphics g ){	
		//System.out.println("animateGrid");
			timer.stop();
			for( int i = 0; i < gridCheckTime.length; i++){
				if( gridCheckTime[i] ){
					animGrid[i].drawAnimatedGrid(g, (i+1)*signal.getGap()+(i+1)*10);
					if( animGrid[i].finished() ){
						//System.out.println("animGrid"+i+"finished");
						animateGrid = false;
						gridCheckTime[i] = false;
						if( i < gridCheckTime.length-1 ){
							gridCheckTime[i+1] = true;
						}
						//System.out.println( "counter = " + counter );
						//System.out.println( "gridCheckTime" + i +
						//	" " + gridCheckTime[i] );
						depth++;
						startTransform = true;
						timer.restart();
					}
				}
			}
	}//end of drawAnimGrid()
		
}//end of class
	