package wavelets;

public class HaarWave extends Wavelet{
	
	public HaarWave(){
		setXScale( new double[]{ 1, 2, 3, 4, 5 } );
		setYScale( new double[]{ 0.5, 1, 1.5, 2, 2.5, 3 } );
	}
	
	public double formula( double t ){
		double x = (t- getB() )/ getA();
		double result;
		
		if( x >= 0 && x < 0.5 ){
			result = 1;
		}
		else if ( x >= 0.5 && x <= 1 ){
			result = -1;
		}
		else{
			result = 0;
		}
		
		return 1/Math.sqrt( getA() ) * result;
	}
}