package wavelets;

public class Morlet extends Wavelet{
	private double w0;
	
	public Morlet(){
		w0 = 0.8;
		setXScale( new double[]{ 2, 4, 6, 8, 10 } );
		setYScale( new double[]{ 0.25, 0.5, 0.75, 1 } );
	}
	
	public double formula( double t ){
		double x = ( t - getB() ) / getA();
				
		double interim1 = 1 / (Math.sqrt( 2 * Math.PI ) );
		double interim2 = -Math.pow( x, 2 )/ 2;
		double interim3 = Math.cos( 2 * Math.PI * w0 * x );
		
		double result = interim1 * Math.exp( interim2 ) * interim3;
		
		return 1/Math.sqrt( getA() ) * result;
	}
	
	public void setW( double w){
		w0 = w;
	}
}